include	clib.inc
include io.inc
include share.inc
include stdio.inc
include fcntl.inc
include stat.inc
include errno.inc

	.186

	extrn	_fmode:WORD
	extrn	_umaskval:WORD

CPROC	sopen, path:DPTR, oflag:WORD, shflag:WORD, va_list:DPTR
	PUSH	SI
	PUSH	DI
	MOV	SI,FH_TEXT
	CMP	_fmode,O_BINARY
	JE	SOPEN_00
	MOV	AX,oflag
	TEST	AX,O_BINARY
	JZ	SOPEN_00
	XOR	SI,SI
SOPEN_00:
	AND	AX,O_RDONLY OR O_WRONLY OR O_RDWR
	CMP	AX,O_RDONLY
	JE	SOPEN_02
	CMP	AX,O_WRONLY
	JE	SOPEN_02
	CMP	AX,O_RDWR
	JE	SOPEN_02
SOPEN_01:
	MOV	errno,EINVAL
	XOR	AX,AX
	MOV	doserrno,AX
	DEC	AX
	JMP	SOPEN_END
SOPEN_02:
	MOV	DI,AX
	MOV	AX,oflag
	AND	AX,O_CREAT OR O_EXCL OR O_TRUNC
	JZ	SOPEN_03
	CMP	AX,O_EXCL
	JE	SOPEN_03
	CMP	AX,O_CREAT
	JE	SOPEN_04
	CMP	AX,O_CREAT OR O_TRUNC
	JE	SOPEN_05
	CMP	AX,O_CREAT OR O_EXCL
	JE	SOPEN_05
	CMP	AX,O_CREAT OR O_TRUNC OR O_EXCL
	JE	SOPEN_05
	CMP	AX,O_TRUNC
	JE	SOPEN_06
	CMP	AX,O_TRUNC OR O_EXCL
	JE	SOPEN_06
	JMP	SOPEN_01
SOPEN_03:
	MOV	AX,A_OPEN
	JMP	SOPEN_07
SOPEN_04:
	MOV	AX,A_OPEN OR A_CREATE
	JMP	SOPEN_07
SOPEN_05:
	MOV	AX,A_CREATE OR A_TRUNC
	JMP	SOPEN_07
SOPEN_06:
	MOV	AX,A_TRUNC
SOPEN_07:
	MOV	CX,_A_NORMAL
	MOV	DX,oflag
	TEST	DX,O_CREAT
	JZ	SOPEN_08
	LEA	BX,[BP+ARG1+2+2+DPTRZ]
	PUSH	AX
	MOV	AX,SS:[BX]
	MOV	BX,_umaskval
	NOT	BX
	AND	AX,BX
	AND	AX,S_IWRITE
	POP	AX
	JNZ	SOPEN_08
	MOV	CX,_A_RDONLY
SOPEN_08:
	TEST	DX,O_TEMPORARY
	JZ	SOPEN_09
	OR	CX,_A_DELETE
	OR	DI,O_SHORT_LIVED
SOPEN_09:
	TEST	DX,O_SHORT_LIVED
	JZ	SOPEN_10
	OR	CX,_A_TEMPORARY
SOPEN_10:
	TEST	DX,O_SEQUENTIAL
	JZ	SOPEN_11
	OR	CX,_A_SEQSCAN
	JMP	SOPEN_12
SOPEN_11:
	TEST	DX,O_RANDOM
	JZ	SOPEN_12
	OR	CX,_A_RANDOM
SOPEN_12:
	MPUSH	WORD PTR path+2
	PUSH	WORD PTR path
	PUSH	CX
	PUSH	DI
	PUSH	AX
	CALL	osopen
	CMP	AX,-1
	JNE	SOPEN_12A
	JMP	SOPEN_END
SOPEN_12A:
	MOV	DI,AX
	PUSH	AX
	CALL	osfiletype
	CMP	AX,DEV_UNKNOWN
	JNE	SOPEN_12B
	JMP	SOPEN_ERR
SOPEN_12B:
	CMP	AX,DEV_CHAR
	JNE	SOPEN_13
	OR	SI,FH_DEVICE
SOPEN_13:
	OR	SI,FH_OPEN
	MOV	AX,SI
	MOV	_osfile[DI],AL
	TEST	AL,FH_DEVICE OR FH_PIPE
	JNZ	SOPEN_15
	TEST	AL,FH_TEXT
	JZ	SOPEN_15
	TEST	oflag,O_RDWR
	JZ	SOPEN_15
	PUSH	DI
	MOV	AX,-1
	PUSH	AX
	PUSH	AX
	PUSH	SEEK_END
	CALL	lseek
	CMP	DX,-1
	JNE	SOPEN_14
	CMP	AX,-1
	JNE	SOPEN_14
	CMP	errno,EINVAL
	JNE	SOPEN_ER2
	JMP	SOPEN_15
SOPEN_14:
	PUSH	DX
	PUSH	AX
	XOR	AX,AX
	MOV	WORD PTR path,AX
	PUSH	DI
	LEA	AX,path
	PUSH	SS
	PUSH	AX
	PUSH	1
	CALL	osread
	OR	AX,AX
	POP	AX
	POP	DX
	JNZ	SOPEN_14A
	CMP	BYTE PTR path,26
	JNE	SOPEN_14B
SOPEN_14A:
	PUSH	DI
	PUSH	DX
	PUSH	AX
	CALL	chsize
	CMP	AX,-1
	JE	SOPEN_ER2
SOPEN_14B:
	PUSH	DI
	PUSH	0
	PUSH	0
	PUSH	SEEK_SET
	CALL	lseek
	CMP	DX,-1
	JNE	SOPEN_15
	CMP	AX,-1
	JE	SOPEN_ER2
SOPEN_15:
	MOV	AX,SI
	AND	AX,FH_DEVICE OR FH_PIPE
	JNZ	SOPEN_16
	TEST	oflag,O_APPEND
	JZ	SOPEN_16
	OR	_osfile[DI],FH_APPEND
SOPEN_16:
	MOV	AX,DI
SOPEN_END:
	POP	DI
	POP	SI
	RET
SOPEN_ERR:
	MOV	AX,doserrno
	CALL	@dosmaper
SOPEN_ER2:
	PUSH	DI
	CALL	close
	MOV	AX,-1
	JMP	SOPEN_END
PEND	sopen

	END
